- Qt 5.15
- Qt Core
- C++ Classes
- QAbstractState
- Qt 5.15.19 Reference Documentation

# QAbstractState Class

The QAbstractState class is the base class of states of a QStateMachine. More...

Header: | #include <QAbstractState>
qmake: | QT += core
Since: | Qt 4.6
Inherits: | QObject
Inherited By: | QFinalState, QHistoryState, and QState

This class was introduced in Qt 4.6.

- List of all members, including inherited members

## Properties

- active : const bool

## Public Functions

virtual | ~QAbstractState()
bool | active() const
QStateMachine * | machine() const
QState * | parentState() const

## Signals

void | activeChanged(bool active)

## Protected Functions

| QAbstractState(QState *parent = nullptr)
virtual void | onEntry(QEvent *event) = 0
virtual void | onExit(QEvent *event) = 0

## Reimplemented Protected Functions

virtual bool | event(QEvent *e) override

## Detailed Description

The QAbstractState class is the abstract base class of states that are part of a QStateMachine. It defines the interface that all state objects have in common. QAbstractState is part of The State Machine Framework.

The entered() signal is emitted when the state has been entered. The exited() signal is emitted when the state has been exited.

The parentState() function returns the state's parent state. The machine() function returns the state machine that the state is part of.

### Subclassing

The onEntry() function is called when the state is entered; reimplement this function to perform custom processing when the state is entered.

The onExit() function is called when the state is exited; reimplement this function to perform custom processing when the state is exited.

## Property Documentation

### active : const bool

This property holds the active property of this state. A state is active between entered() and exited() signals.

This property was introduced in Qt 5.4.

Access functions:

bool | active() const

Notifier signal:

void | activeChanged(bool active)

## Member Function Documentation

### `[protected]` QAbstractState::QAbstractState(QState *parent = nullptr)

Constructs a new state with the given parent state.

### `[signal]` void QAbstractState::activeChanged(bool active)

This signal is emitted when the active property is changed with active as argument.

Note: Notifier signal for property active.

This function was introduced in Qt 5.4.

See also QAbstractState::active, entered(), and exited().

### `[virtual]` QAbstractState::~QAbstractState()

Destroys this state.

### bool QAbstractState::active() const

Returns whether this state is active.

Note: Getter function for property active.

See also activeChanged(bool), entered(), and exited().

### `[override virtual protected]` bool QAbstractState::event(QEvent *e)

Reimplements: QObject::event(QEvent *e).

### QStateMachine *QAbstractState::machine() const

Returns the state machine that this state is part of, or `nullptr` if the state is not part of a state machine.

### `[pure virtual protected]` void QAbstractState::onEntry(QEvent *event)

This function is called when the state is entered. The given event is what caused the state to be entered. Reimplement this function to perform custom processing when the state is entered.

### `[pure virtual protected]` void QAbstractState::onExit(QEvent *event)

This function is called when the state is exited. The given event is what caused the state to be exited. Reimplement this function to perform custom processing when the state is exited.

### QState *QAbstractState::parentState() const

Returns this state's parent state, or `nullptr` if the state has no parent state.